//  Xbox360 Input Machine  Test Program  by kako

#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <mmsystem.h>
#include "XIMcore.h"

XIMXbox360Input xi;
JOYINFOEX ji;
JOYCAPS jcap;
int max,jy;
int axis,buttons;
int pov,button;
int x1,y1,x2,y2;

int main()
{
	int ret;
	
	printf("Checking PC Joystick...\n");
	max=joyGetNumDevs();
	jy= -1;
	for (int i=0;i<max;i++) {
		ret=joyGetDevCaps(i,&jcap,sizeof(JOYCAPS));
		if (ret==JOYERR_NOERROR) { jy=i; }
	}
	if (jy == -1) {
		printf("Joystick NOT found.\n"); getch(); exit(1);
	}

	ret=joyGetDevCaps(jy,&jcap,sizeof(JOYCAPS));
	axis=jcap.wNumAxes;  buttons=jcap.wNumButtons;
	printf("Joystick Axis=%d , Buttons=%d\n",axis,buttons);
	
	ji.dwFlags = JOY_RETURNALL | JOY_RETURNPOV | JOY_RETURNPOVCTS;
	ji.dwSize = sizeof(JOYINFOEX);
	for (int i=0;i<16;i++) {
		joyGetPosEx(jy , &ji); // dummy read to avoid initial garbage  for some joypad
	}
	printf("\n");
	
	printf("Checking XIM...\n");
	ret = XIMConnect();
	if (ret != XIMSTATUS_OK) {
		printf("XIM Connect error (%d)\n",ret); getch(); exit(1);
	}
	printf("XIM Connect OK\n");
	printf("\n");
	printf("XIM Send testing...\n");
	XIMSendXbox360Input(&xi);
	printf("XIM Send OK\n");
	printf("\n");
	printf("XIM Key Input started. (ESC key to quit.)\n");
	
	while (1) {
		if (kbhit()) { if( getch()==0x1B ) break; }
		joyGetPosEx(jy , &ji);
		
		xi.Up=FALSE; xi.Down=FALSE; xi.Left=FALSE; xi.Right=FALSE;
		xi.A=FALSE; xi.B=FALSE; xi.X=FALSE; xi.Y=FALSE; xi.Back=FALSE; xi.Start=FALSE;
		xi.LeftTrigger=FALSE; xi.RightTrigger=FALSE; xi.LeftBumper=FALSE; xi.RightBumper=FALSE;
		
		pov = ji.dwPOV / 100;
		if (ji.dwPOV == 0xFFFF) { pov = -1; }
		if (pov==0)   { xi.Up   =TRUE;                }
		if (pov==45)  { xi.Up   =TRUE; xi.Right=TRUE; }
		if (pov==90)  { xi.Right=TRUE;                }
		if (pov==135) { xi.Right=TRUE; xi.Down=TRUE;  }
		if (pov==180) { xi.Down =TRUE;                }
		if (pov==225) { xi.Down =TRUE; xi.Left=TRUE;  }
		if (pov==270) { xi.Left =TRUE;                }
		if (pov==315) { xi.Left =TRUE; xi.Up=TRUE;    }
		
		button=ji.dwButtons;
		if (button & 0x001) { xi.Y  = TRUE; } // { xi.A  = TRUE; }
		if (button & 0x002) { xi.B  = TRUE; } // { xi.B  = TRUE; }
		if (button & 0x004) { xi.A  = TRUE; } // { xi.X  = TRUE; }
		if (button & 0x008) { xi.X  = TRUE; } // { xi.Y  = TRUE; }
		if (button & 0x010) { xi.LeftTrigger  = TRUE; } // { xi.LeftBumper  = TRUE; }
		if (button & 0x020) { xi.RightTrigger = TRUE; } // { xi.RightBumper = TRUE; }
		if (button & 0x040) { xi.LeftTrigger  = TRUE; }
		if (button & 0x080) { xi.RightTrigger = TRUE; }
		if (button & 0x100) { xi.Start   = TRUE; }   // { xi.Back   = TRUE; }
		if (button & 0x200) { xi.Start  = TRUE; }
		if (button & 0x400) { xi.LeftStick   = TRUE; }
		if (button & 0x800) { xi.RightStick  = TRUE; }
		
		if (axis>2) {
			x1=ji.dwXpos; y1=ji.dwYpos;
			x2=ji.dwZpos; y2=ji.dwRpos;   //x2=ji.dwRpos; y2=ji.dwZpos;
			if (axis==5) { x2=ji.dwUpos; y2=ji.dwRpos; }
		} else {
			x1 = x2 = y1 = y2 = 0x7FFF;
		}
		x1 -= 0x7FFF;  y1 -= 0x7FFF;  x2 -= 0x7FFF;  y2 -= 0x7FFF;
		x1 /= 256;     y1 /= 256;     x2 /= 256;     y2 /= 256;
		if (x1> 127) { x1=  127; } else if (x1<-127) { x1= -127; }
		if (y1> 127) { y1=  127; } else if (y1<-127) { y1= -127; }
		if (x2> 127) { x2=  127; } else if (x2<-127) { x2= -127; }
		if (y2> 127) { y2=  127; } else if (y2<-127) { y2= -127; }
		y1 = -y1;  y2 = -y2;  // Invert Y-axis analog stick
		xi.LeftStickX  = x1; xi.LeftStickY  = y1;
		xi.RightStickX = x2; xi.RightStickY = y2;
		
		XIMSendXbox360Input(&xi);
	}
	printf("Quit.\n");
	XIMDisconnect();
	
	return 0;
}
